$:.unshift(File.dirname(__FILE__)) unless
  $:.include?(File.dirname(__FILE__)) || $:.include?(File.expand_path(File.dirname(__FILE__)))

module TerminalDispayColors
  VERSION = '0.1.0'

  colors = {
    'black'   => "\033[30m",
    'red'     => "\033[31m",
    'green'   => "\033[32m",
    'yellow'  => "\033[33m",
    'blue'    => "\033[34m",
    'magenta' => "\033[35m",
    'cyan'    => "\033[36m",
    'gray'    => "\033[37m",

    'dark_gray'       => "\033[90m",
    'bright_red'      => "\033[91m",
    'bright_green'    => "\033[92m",
    'bright_yellow'   => "\033[93m",
    'bright_blue'     => "\033[94m",
    'bright_magenta'  => "\033[95m",
    'bright_cyan'     => "\033[96m",
    'white'           => "\033[97m",

    'black_background'    => "\033[40m",
    'red_background'      => "\033[41m",
    'green_background'    => "\033[42m",
    'yellow_background'   => "\033[43m",
    'blue_background'     => "\033[44m",
    'magenta_background'  => "\033[45m",
    'cyan_background'     => "\033[46m",
    'gray_background'     => "\033[47m",

    'dark_gray_background'      => "\033[100m",
    'bright_red_background'     => "\033[101m",
    'bright_green_background'   => "\033[102m",
    'bright_yellow_background'  => "\033[103m",
    'bright_blue_background'    => "\033[104m",
    'bright_magenta_background' => "\033[105m",
    'bright_cyan_background'    => "\033[106m",
    'white_background'          => "\033[107m"
  }
  ending  = "\033[00m"

  colors.keys.each do | color |
    color_block = lambda {
      colors[ color ] + self + ending
    }
    String.send( :define_method, color.to_sym, color_block )
  end

  rgb_colors = {
    '#000000' => 16,  # Grey0
    '#00005f' => 17,  # NavyBlue
    '#000087' => 18,  # DarkBlue
    '#0000af' => 19,  # Blue3
    '#0000d7' => 20,  # Blue3
    '#0000ff' => 21,  # Blue1
    '#005f00' => 22,  # DarkGreen
    '#005f5f' => 23,  # DeepSkyBlue4
    '#005f87' => 24,  # DeepSkyBlue4
    '#005faf' => 25,  # DeepSkyBlue4
    '#005fd7' => 26,  # DodgerBlue3
    '#005fff' => 27,  # DodgerBlue2
    '#008700' => 28,  # Green4
    '#00875f' => 29,  # SpringGreen4
    '#008787' => 30,  # Turquoise4
    '#0087af' => 31,  # DeepSkyBlue3
    '#0087d7' => 32,  # DeepSkyBlue3
    '#0087ff' => 33,  # DodgerBlue1
    '#00af00' => 34,  # Green3
    '#00af5f' => 35,  # SpringGreen3
    '#00af87' => 36,  # DarkCyan
    '#00afaf' => 37,  # LightSeaGreen
    '#00afd7' => 38,  # DeepSkyBlue2
    '#00afff' => 39,  # DeepSkyBlue1
    '#00d700' => 40,  # Green3
    '#00d75f' => 41,  # SpringGreen3
    '#00d787' => 42,  # SpringGreen2
    '#00d7af' => 43,  # Cyan3
    '#00d7d7' => 44,  # DarkTurquoise
    '#00d7ff' => 45,  # Turquoise2
    '#00ff00' => 46,  # Green1
    '#00ff5f' => 47,  # SpringGreen2
    '#00ff87' => 48,  # SpringGreen1
    '#00ffaf' => 49,  # MediumSpringGreen
    '#00ffd7' => 50,  # Cyan2
    '#00ffff' => 51,  # Cyan1
    '#5f0000' => 52,  # DarkRed
    '#5f005f' => 53,  # DeepPink4
    '#5f0087' => 54,  # Purple4
    '#5f00af' => 55,  # Purple4
    '#5f00d7' => 56,  # Purple3
    '#5f00ff' => 57,  # BlueViolet
    '#5f5f00' => 58,  # Orange4
    '#5f5f5f' => 59,  # Grey37
    '#5f5f87' => 60,  # MediumPurple4
    '#5f5faf' => 61,  # SlateBlue3
    '#5f5fd7' => 62,  # SlateBlue3
    '#5f5fff' => 63,  # RoyalBlue1
    '#5f8700' => 64,  # Chartreuse4
    '#5f875f' => 65,  # DarkSeaGreen4
    '#5f8787' => 66,  # PaleTurquoise4
    '#5f87af' => 67,  # SteelBlue
    '#5f87d7' => 68,  # SteelBlue3
    '#5f87ff' => 69,  # CornflowerBlue
    '#5faf00' => 70,  # Chartreuse3
    '#5faf5f' => 71,  # DarkSeaGreen4
    '#5faf87' => 72,  # CadetBlue
    '#5fafaf' => 73,  # CadetBlue
    '#5fafd7' => 74,  # SkyBlue3
    '#5fafff' => 75,  # SteelBlue1
    '#5fd700' => 76,  # Chartreuse3
    '#5fd75f' => 77,  # PaleGreen3
    '#5fd787' => 78,  # SeaGreen3
    '#5fd7af' => 79,  # Aquamarine3
    '#5fd7d7' => 80,  # MediumTurquoise
    '#5fd7ff' => 81,  # SteelBlue1
    '#5fff00' => 82,  # Chartreuse2
    '#5fff5f' => 83,  # SeaGreen2
    '#5fff87' => 84,  # SeaGreen1
    '#5fffaf' => 85,  # SeaGreen1
    '#5fffd7' => 86,  # Aquamarine1
    '#5fffff' => 87,  # DarkSlateGray2
    '#870000' => 88,  # DarkRed
    '#87005f' => 89,  # DeepPink4
    '#870087' => 90,  # DarkMagenta
    '#8700af' => 91,  # DarkMagenta
    '#8700d7' => 92,  # DarkViolet
    '#8700ff' => 93,  # Purple
    '#875f00' => 94,  # Orange4
    '#875f5f' => 95,  # LightPink4
    '#875f87' => 96,  # Plum4
    '#875faf' => 97,  # MediumPurple3
    '#875fd7' => 98,  # MediumPurple3
    '#875fff' => 99,  # SlateBlue1
    '#878700' => 100,  # Yellow4
    '#87875f' => 101,  # Wheat4
    '#878787' => 102,  # Grey53
    '#8787af' => 103,  # LightSlateGrey
    '#8787d7' => 104,  # MediumPurple
    '#8787ff' => 105,  # LightSlateBlue
    '#87af00' => 106,  # Yellow4
    '#87af5f' => 107,  # DarkOliveGreen3
    '#87af87' => 108,  # DarkSeaGreen
    '#87afaf' => 109,  # LightSkyBlue3
    '#87afd7' => 110,  # LightSkyBlue3
    '#87afff' => 111,  # SkyBlue2
    '#87d700' => 112,  # Chartreuse2
    '#87d75f' => 113,  # DarkOliveGreen3
    '#87d787' => 114,  # PaleGreen3
    '#87d7af' => 115,  # DarkSeaGreen3
    '#87d7d7' => 116,  # DarkSlateGray3
    '#87d7ff' => 117,  # SkyBlue1
    '#87ff00' => 118,  # Chartreuse1
    '#87ff5f' => 119,  # LightGreen
    '#87ff87' => 120,  # LightGreen
    '#87ffaf' => 121,  # PaleGreen1
    '#87ffd7' => 122,  # Aquamarine1
    '#87ffff' => 123,  # DarkSlateGray1
    '#af0000' => 124,  # Red3
    '#af005f' => 125,  # DeepPink4
    '#af0087' => 126,  # MediumVioletRed
    '#af00af' => 127,  # Magenta3
    '#af00d7' => 128,  # DarkViolet
    '#af00ff' => 129,  # Purple
    '#af5f00' => 130,  # DarkOrange3
    '#af5f5f' => 131,  # IndianRed
    '#af5f87' => 132,  # HotPink3
    '#af5faf' => 133,  # MediumOrchid3
    '#af5fd7' => 134,  # MediumOrchid
    '#af5fff' => 135,  # MediumPurple2
    '#af8700' => 136,  # DarkGoldenrod
    '#af875f' => 137,  # LightSalmon3
    '#af8787' => 138,  # RosyBrown
    '#af87af' => 139,  # Grey63
    '#af87d7' => 140,  # MediumPurple2
    '#af87ff' => 141,  # MediumPurple1
    '#afaf00' => 142,  # Gold3
    '#afaf5f' => 143,  # DarkKhaki
    '#afaf87' => 144,  # NavajoWhite3
    '#afafaf' => 145,  # Grey69
    '#afafd7' => 146,  # LightSteelBlue3
    '#afafff' => 147,  # LightSteelBlue
    '#afd700' => 148,  # Yellow3
    '#afd75f' => 149,  # DarkOliveGreen3
    '#afd787' => 150,  # DarkSeaGreen3
    '#afd7af' => 151,  # DarkSeaGreen2
    '#afd7d7' => 152,  # LightCyan3
    '#afd7ff' => 153,  # LightSkyBlue1
    '#afff00' => 154,  # GreenYellow
    '#afff5f' => 155,  # DarkOliveGreen2
    '#afff87' => 156,  # PaleGreen1
    '#afffaf' => 157,  # DarkSeaGreen2
    '#afffd7' => 158,  # DarkSeaGreen1
    '#afffff' => 159,  # PaleTurquoise1
    '#d70000' => 160,  # Red3
    '#d7005f' => 161,  # DeepPink3
    '#d70087' => 162,  # DeepPink3
    '#d700af' => 163,  # Magenta3
    '#d700d7' => 164,  # Magenta3
    '#d700ff' => 165,  # Magenta2
    '#d75f00' => 166,  # DarkOrange3
    '#d75f5f' => 167,  # IndianRed
    '#d75f87' => 168,  # HotPink3
    '#d75faf' => 169,  # HotPink2
    '#d75fd7' => 170,  # Orchid
    '#d75fff' => 171,  # MediumOrchid1
    '#d78700' => 172,  # Orange3
    '#d7875f' => 173,  # LightSalmon3
    '#d78787' => 174,  # LightPink3
    '#d787af' => 175,  # Pink3
    '#d787d7' => 176,  # Plum3
    '#d787ff' => 177,  # Violet
    '#d7af00' => 178,  # Gold3
    '#d7af5f' => 179,  # LightGoldenrod3
    '#d7af87' => 180,  # Tan
    '#d7afaf' => 181,  # MistyRose3
    '#d7afd7' => 182,  # Thistle3
    '#d7afff' => 183,  # Plum2
    '#d7d700' => 184,  # Yellow3
    '#d7d75f' => 185,  # Khaki3
    '#d7d787' => 186,  # LightGoldenrod2
    '#d7d7af' => 187,  # LightYellow3
    '#d7d7d7' => 188,  # Grey84
    '#d7d7ff' => 189,  # LightSteelBlue1
    '#d7ff00' => 190,  # Yellow2
    '#d7ff5f' => 191,  # DarkOliveGreen1
    '#d7ff87' => 192,  # DarkOliveGreen1
    '#d7ffaf' => 193,  # DarkSeaGreen1
    '#d7ffd7' => 194,  # Honeydew2
    '#d7ffff' => 195,  # LightCyan1
    '#ff0000' => 196,  # Red1
    '#ff005f' => 197,  # DeepPink2
    '#ff0087' => 198,  # DeepPink1
    '#ff00af' => 199,  # DeepPink1
    '#ff00d7' => 200,  # Magenta2
    '#ff00ff' => 201,  # Magenta1
    '#ff5f00' => 202,  # OrangeRed1
    '#ff5f5f' => 203,  # IndianRed1
    '#ff5f87' => 204,  # IndianRed1
    '#ff5faf' => 205,  # HotPink
    '#ff5fd7' => 206,  # HotPink
    '#ff5fff' => 207,  # MediumOrchid1
    '#ff8700' => 208,  # DarkOrange
    '#ff875f' => 209,  # Salmon1
    '#ff8787' => 210,  # LightCoral
    '#ff87af' => 211,  # PaleVioletRed1
    '#ff87d7' => 212,  # Orchid2
    '#ff87ff' => 213,  # Orchid1
    '#ffaf00' => 214,  # Orange1
    '#ffaf5f' => 215,  # SandyBrown
    '#ffaf87' => 216,  # LightSalmon1
    '#ffafaf' => 217,  # LightPink1
    '#ffafd7' => 218,  # Pink1
    '#ffafff' => 219,  # Plum1
    '#ffd700' => 220,  # Gold1
    '#ffd75f' => 221,  # LightGoldenrod2
    '#ffd787' => 222,  # LightGoldenrod2
    '#ffd7af' => 223,  # NavajoWhite1
    '#ffd7d7' => 224,  # MistyRose1
    '#ffd7ff' => 225,  # Thistle1
    '#ffff00' => 226,  # Yellow1
    '#ffff5f' => 227,  # LightGoldenrod1
    '#ffff87' => 228,  # Khaki1
    '#ffffaf' => 229,  # Wheat1
    '#ffffd7' => 230,  # Cornsilk1
    '#ffffff' => 231,  # Grey100
    '#080808' => 232,  # Grey3
    '#121212' => 233,  # Grey7
    '#1c1c1c' => 234,  # Grey11
    '#262626' => 235,  # Grey15
    '#303030' => 236,  # Grey19
    '#3a3a3a' => 237,  # Grey23
    '#444444' => 238,  # Grey27
    '#4e4e4e' => 239,  # Grey30
    '#585858' => 240,  # Grey35
    '#626262' => 241,  # Grey39
    '#6c6c6c' => 242,  # Grey42
    '#767676' => 243,  # Grey46
    '#808080' => 244,  # Grey50
    '#8a8a8a' => 245,  # Grey54
    '#949494' => 246,  # Grey58
    '#9e9e9e' => 247,  # Grey62
    '#a8a8a8' => 248,  # Grey66
    '#b2b2b2' => 249,  # Grey70
    '#bcbcbc' => 250,  # Grey74
    '#c6c6c6' => 251,  # Grey78
    '#d0d0d0' => 252,  # Grey82
    '#dadada' => 253,  # Grey85
    '#e4e4e4' => 254,  # Grey89
    '#eeeeee' => 255   # Grey93
  }

  color_block = lambda { | rgb_hex |
    "\033[38;5;#{ rgb_colors[ rgb_hex.downcase ] }m" + self + ending
  }
  String.send( :define_method, :color, color_block )

  color_block = lambda { | rgb_hex |
    "\033[48;5;#{ rgb_colors[ rgb_hex.downcase ] }m" + self + ending
  }
  String.send( :define_method, :background, color_block )
end
